<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Debug ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Debug extends AbstractStructArrayBase
{
    /**
     * The Debug
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Debug[]
     */
    public $Debug;
    /**
     * Constructor method for ArrayOfJP_Debug
     * @uses ArrayOfJP_Debug::setDebug()
     * @param \StructType\JP_Debug[] $debug
     */
    public function __construct(array $debug = array())
    {
        $this
            ->setDebug($debug);
    }
    /**
     * Get Debug value
     * @return \StructType\JP_Debug[]|null
     */
    public function getDebug()
    {
        return $this->Debug;
    }
    /**
     * Set Debug value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Debug[] $debug
     * @return \ArrayType\ArrayOfJP_Debug
     */
    public function setDebug(array $debug = array())
    {
        foreach ($debug as $arrayOfJP_DebugDebugItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_DebugDebugItem instanceof \StructType\JP_Debug) {
                throw new \InvalidArgumentException(sprintf('The Debug property can only contain items of \StructType\JP_Debug, "%s" given', is_object($arrayOfJP_DebugDebugItem) ? get_class($arrayOfJP_DebugDebugItem) : gettype($arrayOfJP_DebugDebugItem)), __LINE__);
            }
        }
        $this->Debug = $debug;
        return $this;
    }
    /**
     * Add item to Debug value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Debug $item
     * @return \ArrayType\ArrayOfJP_Debug
     */
    public function addToDebug(\StructType\JP_Debug $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Debug) {
            throw new \InvalidArgumentException(sprintf('The Debug property can only contain items of \StructType\JP_Debug, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Debug[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Debug|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Debug|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Debug|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Debug|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Debug|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Debug
     */
    public function getAttributeName()
    {
        return 'Debug';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Debug
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
